--- old/usr/src/uts/common/fs/vnode.c	Mon Jul 22 17:46:48 2013
+++ new/usr/src/uts/common/fs/vnode.c	Mon Jul 22 17:46:48 2013
@@ -65,6 +65,7 @@
 #include <fs/fs_subr.h>
 #include <sys/taskq.h>
 #include <fs/fs_reparse.h>
+#include <sys/fsh_impl.h>
 
 /* Determine if this vnode is a file that is read-only */
 #define	ISROFILE(vp)	\
@@ -3142,7 +3143,11 @@
 
 	VOPXID_MAP_CR(vp, cr);
 
-	ret = (*(*(vpp))->v_op->vop_open)(vpp, mode, cr, ct);
+	/*
+	 * Control is passed to fsh. In the end, underlying vop_vopen()
+	 * is called.
+	 */
+	ret = fsh_open(vpp, mode, cr, ct);
 
 	if (ret) {
 		/*
@@ -3193,7 +3198,7 @@
 
 	VOPXID_MAP_CR(vp, cr);
 
-	err = (*(vp)->v_op->vop_close)(vp, flag, count, offset, cr, ct);
+	err = fsh_close(vp, flag, count, offset, cr, ct);
 	VOPSTATS_UPDATE(vp, close);
 	/*
 	 * Check passed in count to handle possible dups. Vnode counts are only
@@ -3225,7 +3230,7 @@
 
 	VOPXID_MAP_CR(vp, cr);
 
-	err = (*(vp)->v_op->vop_read)(vp, uiop, ioflag, cr, ct);
+	err = fsh_read(vp, uiop, ioflag, cr, ct);
 	VOPSTATS_UPDATE_IO(vp, read,
 	    read_bytes, (resid_start - uiop->uio_resid));
 	return (err);
@@ -3244,7 +3249,7 @@
 
 	VOPXID_MAP_CR(vp, cr);
 
-	err = (*(vp)->v_op->vop_write)(vp, uiop, ioflag, cr, ct);
+	err = fsh_write(vp, uiop, ioflag, cr, ct);
 	VOPSTATS_UPDATE_IO(vp, write,
 	    write_bytes, (resid_start - uiop->uio_resid));
 	return (err);
